using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using Meebey.SmartIrc4net;

namespace IRC
{
    public partial class frmChat : Form
    {

        #region Felder
        // Name des Clients
        private string ClientName = "Spieleplanet - Chat by Immnn";
        // Boolean Variable, ob man verbunden ist
        private bool verbunden = false;
        // Auf dem server liegt die Rockshow:
        private string server = "irc.phat-net.de";
        // Standart IRC Port:
        private static int port = 6667;
        // Rockshow Channel:
        private static string channel = "#Spiele";
        // Nickname
        private string nickname = "SPler";
        private bool registriert = false;
        private string realname = "Spieleplanet Client - By Pat";
        // Variable fr den Query
        private string QueryNick = "TEST"; 
        // Eingehende Nachricht
        private string nachricht;
        private bool fehler;
        #endregion

        #region bullshit
        public frmChat()
        {
            InitializeComponent();
        }
        #endregion

        #region Form_Load

        private void Form1_Load(object sender, EventArgs e)
        {
            this.Text = ClientName;
            lstUser.Items.Clear();
            CheckForIllegalCrossThreadCalls = false;

            
            lade.Einlesen();
            if (lade._fehler == true)
            {
                MessageBox.Show("Ein Fehler ist aufgetreten beim laden der Config.cfg. Erstell mal schnell eine Neue ;)");
                settings.ShowDialog();
                lade.Einlesen();
                lblNick.Text = nickname.ToString();
            }
            else if (lade._fehler == false)
            {
                channel = lade._channel;
                server = lade._server;
                nickname = lade._nickname;
                lblNick.Text = nickname;
                realname = lade._realname;
                port = lade._port;
                fehler = lade._fehler;
                txtChat.AppendText("Einstellungen vollstndig geladen!\r\n");
            }
        }

        #endregion

        // die High-Level API instanziieren
        private static IrcClient irc = new IrcClient();
        FrmEinstellungen settings = new FrmEinstellungen();
        Lade_Einstellungen lade = new Lade_Einstellungen();
        LadeScreen LadeScreen = new LadeScreen();

        #region Timer, Threadbedingte Sachen

        // Der Timer interrupt
        private void trRefresh_Tick(object sender, EventArgs e)
        {
            if (verbunden == true)
                RefreshUser();
        }

        // Der Zweite Thread
        public static Thread ListenThread;

        // Delegate fr Listen()
        public delegate void ListenToServerDelegate();
        #endregion

        #region Methoden

        #region Start
        private void StartSequenz()
        {
            if (fehler == true)
            {
                MessageBox.Show("Fehler in der Config.");
                bye();
            }
            if (verbunden == true)
            {
                MessageBox.Show("Du bist bereits Verbunden!");
            }
            else if(verbunden == false && fehler == false)
            {
                lade.Einlesen();
                channel = lade._channel;
                server = lade._server;
                nickname = lade._nickname;
                lblNick.Text = nickname;
                realname = lade._realname;
                port = lade._port;
                fehler = lade._fehler;

                lblNick.Text = nickname.ToString();
                
                // Zum Server verbinden
                Connect();
                // Lade Balken ffnen
                LadeScreen.ShowDialog();
                ListenToServerDelegate listen = new ListenToServerDelegate(Listen);   
            }
            
        }
        #endregion

        #region Connection, UserAnzeigen, RefreshUser, Verbunden
        public void Connect()
        {
            Thread.CurrentThread.Name = "Main";

            // Whrend der Nachrichten warten um Flooding zu vermeiden
            irc.SendDelay = 100;

            // ChannelSync verwenden. Dadurch knnen wir irc.GetChannel()
            // etc. verwenden
            irc.ActiveChannelSyncing = true;

            // Events des Programms mit die der API verbinden
            irc.OnError += new ErrorEventHandler(Fehler);
            irc.OnRawMessage += new IrcEventHandler(EingehendeNachricht);

            // Wir versuchen nun eine Verbindung zum Server aufzubauen
            try
            {
                irc.Connect(server, port);
            }
            catch (ConnectionException a)
            {
                // Fehler abfangen
                MessageBox.Show(a.Message);
                bye();
            }

            try
            {
                // Nun loggin wir uns ein und Registrieren unseren Nickname
                irc.Login(nickname, realname);

                // den Channel joinen
                irc.RfcJoin(channel);

                // Den ListenThread starten
                ListenThread = new Thread(new ThreadStart(Listen));
                ListenThread.Start();
                
            }
            catch (ConnectionException)
            {
                bye();
            }
            catch (Exception a)
            {
                MessageBox.Show("Fehler: " + a.Message);
                bye();
            }
        }
        public void UserAnzeigen()
        {
            lstUser.Items.Clear();
            // Der Channel
            Channel chan = irc.GetChannel(channel.ToString());
            foreach (ChannelUser cuser in chan.Users.Values)
            {
                lstUser.Items.Add(cuser.Nick.ToString());
            }
        }
        public void RefreshUser()
        {
            UserAnzeigen();
            nickname = irc.Nickname;
            lblNick.Text = nickname.ToString();
        }
        public void Verbunden()
        {
            txtChat.Text = "";
            txtChat.AppendText("===========================================================================\r\n" +
                "Willkommen im Chat von www.spieleplanet.ch\r\n\r\n" +
                "Geschrieben wurde dieser Client von Immnn .. Feedback & Bugs bitte ins Forum =)\r\n" +
                "===========================================================================\r\n\r\n");
            if (registriert == true)
                txtChat.AppendText("Dein Nickname ist registriert.\r\n" + 
                    "Identifiziere dich mit dem Passwort: /I <Passwort>\r\n " + 
                    "Oder whle einen anderen Nickname: /N <Nickname>\r\n\r\n");
            verbunden = true;
            lblInfo.Text = ">>" + realname + "<<, du befindest dich auf dem Server >>" + server + "<< und bist im Channel >>" + channel + "<<";
            LadeScreen.Close();
        }
        #endregion

        #region Listen, OnRawMessage
        public static void Listen()
        {
            irc.Listen();
        }
        #endregion

        #region Fehlerbehandlung, Exit
        // Diese Methode wird Fehler vom IRC Server gehandeln
        public void Fehler(object sender, ErrorEventArgs e)
        {
            MessageBox.Show(e.ErrorMessage.ToString());
            bye();
        }

        // Diese Methode schliet unser Programm
        public void bye()
        {
            // vor dem Beenden die Verbindung schlieend (falls ntig) und Programm schlieen
            if(verbunden==true)
                irc.Disconnect();
            System.Environment.Exit(0);
        }
        #endregion

        #region Nachrichten behandlung


        // Diese Methode kmmert sich um eingehende Nachrichten
        public void EingehendeNachricht(object sender, IrcEventArgs e)
        {
            if (e.Data.Message != null && e.Data.Message.ToString() == "End of Channel Ban List")
            {
                Verbunden();
            }
            if (e.Data.Message != null && e.Data.Message.ToString() == "This nickname is registered and protected.  If it is your")
            {
                registriert = true;
            }
            nachricht = e.Data.Nick + ": ";
            nachricht += e.Data.Message;

            if (nachricht != null)
                txtChat.AppendText(nachricht + "\r\n");
        }
        // Diese Methode sendet Nachrichten
        public void SendMessage()
        {
            // Die Nachricht aus der Textbox versenden
            // Zuerstmal die eigene Nachricht anzeigen
            try
            {
                if (txtMessage.Text.Length >= 2)
                {
                    // herausfinden, ob der User nicht ein Commando meint:
                    string sNachricht = txtMessage.Text.ToString();
                    if (sNachricht[0].ToString() == "/")
                    {
                        string optionen = 
                            "\r\nOptionen:\r\n" +
                            "Nickname ndern: /N <Nickname>\r\n" +
                            "Query Message: /M <Nachricht> - Zudem muss ein Nick aus der Userliste ausgewhlt sein" +
                            "Nickname identifizieren: /I <Passwort>\r\n" +
                            "Beenden: /Q\r\n" +
                            "";
                        // Commando ermitteln:
                        switch (sNachricht[1])
                        {
                            case 'N':
                                // Neuen Nickname zuweisen
                                irc.RfcNick(sNachricht.Remove(0,2));
                                break;
                            case 'I':
                                // Nick identifizieren
                                irc.SendMessage(SendType.Message, "nickserv", "identify " + sNachricht.Remove(0,2));
                                break;
                            case 'R':
                                // Nick reggen
                                irc.SendMessage(SendType.Message, "nickserv", "register " + sNachricht.Remove(0, 2) + " SP@spieleplanet.ch");
                                break;
                            case 'M':
                                // Ermitteln wer gemeint ist:
                                QueryNick = txtQuery.Text;
                                // Value auf Richtigkeit prfen:
                                if (QueryNick.Length > 0)
                                    irc.SendMessage(SendType.Message, QueryNick, sNachricht.Remove(0, 2));
                                break;
                            case 'Q':
                                bye();
                                break;
                            case 'H':
                                txtChat.AppendText(optionen);
                                break;
                            default:
                                txtChat.AppendText(optionen);
                                break;
                        }
                        txtMessage.Text = "";
                    }
                    else if (sNachricht[0].ToString() != "/")
                    {
                        irc.SendMessage(SendType.Message, channel, txtMessage.Text);
                        txtChat.AppendText(nickname + ": " + txtMessage.Text.ToString() + "\r\n");
                        txtMessage.Text = "";
                    }
                }
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message.ToString());
                bye();
            }
        }
        #endregion

        #region Buttons & Events
        // Der eigentliche Programmstart
        private void zumChatVerbindenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            StartSequenz();
        }
        private void btnSend_Click(object sender, EventArgs e)
        {
            SendMessage();
        }
        private void beendenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            bye();
        }
        private void txtMessage_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
                SendMessage();
        }
        private void einstellungenToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            settings.ShowDialog();
        }
        #endregion

        #endregion


    }
}